Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions
kArray1 Class Reference
kApi/Data

## Description

Represents a 1D array.

The kArray1 class represents a 1D array of objects or values. The kArray1 constructor accepts arguments that determine the array item type (kType) and array length.

For arrays that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the array is destroyed. To recursively destroy both the array and the array items, use kObject_Dispose.

kArray1 supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kArray1 supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kArray1:

## Public Member Functions
kStatus | kArray1_Allocate (kArray1 array, kType itemType, kSize length)
| Reallocates the internal array item buffer. More...
kStatus | kArray1_Assign (kArray1 array, kArray1 source)
| Performs a shallow copy of the source array. More...
void * | kArray1_At (kArray1 array, kSize index)
| Returns a pointer to the specified item in the array. More...
kStatus | kArray1_Attach (kArray1 array, void *items, kType itemType, kSize length)
| Attaches the array to an external item buffer. More...
kStatus | kArray1_Construct (kArray1 *array, kType itemType, kSize length, kAlloc allocator)
| Constructs a kArray1 object. More...
kSize | kArray1_Count (kArray1 array)
| Returns the array item count, in elements. More...
void * | kArray1_Data (kArray1 array)
| Returns a pointer to the array item buffer. More...
kSize | kArray1_DataSize (kArray1 array)
| Reports the size, in bytes, of the array item buffer. More...
kStatus | kArray1_Item (kArray1 array, kSize index, void *item)
| Gets the value of an item. More...
kSize | kArray1_ItemSize (kArray1 array)
| Returns the array item size. More...
kType | kArray1_ItemType (kArray1 array)
| Returns the array item type. More...
kSize | kArray1_Length (kArray1 array)
| Returns the array length, in elements. More...
kStatus | kArray1_SetItem (kArray1 array, kSize index, const void *item)
| Sets the value of an item. More...
kStatus | kArray1_Zero (kArray1 array)
| Sets all array element bits to zero. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets the next collection element and then advances the iterator. More...

## Related
#define | kArray1_ItemType_(ARRAY) kxArray1_ItemType_(ARRAY)
| Macro version of kArray1_ItemType.
#define | kArray1_ItemSize_(ARRAY) kxArray1_ItemSize_(ARRAY)
| Macro version of kArray1_ItemSize.
#define | kArray1_Length_(ARRAY) kxArray1_Length_(ARRAY)
| Macro version of kArray1_Length.
#define | kArray1_Count_(ARRAY) kxArray1_Count_(ARRAY)
| Macro version of kArray1_Count.
#define | kArray1_Data_(ARRAY) kxArray1_Data_(ARRAY)
| Macro version of kArray1_Data.
#define | kArray1_DataSize_(ARRAY) kxArray1_DataSize_(ARRAY)
| Macro version of kArray1_DataSize.
#define | kArray1_At_(ARRAY, INDEX) kxArray1_At_(ARRAY, INDEX)
| Macro version of kArray1_At.
#define | kArray1_As_(ARRAY, INDEX, TYPE) kxArray1_As_(ARRAY, INDEX, TYPE)
| Accesses an array element at the specified index, and casts the value to the specified type. More...
Related inherited from kObject
#define | kObject_Type_(OBJ) kxObject_Type_(OBJ)
| Macro version of kObject_Type.
#define | kObject_Is_(OBJ, TYPE) kxObject_Is_(OBJ, TYPE)
| Macro version of kObject_Is.
#define | kObject_Alloc_(OBJ) kxObject_Allocator_(OBJ)
| Macro version of kObject_Alloc.

The documentation for this class was generated from the following file:

- Data/kArray1.h